package Shape;

import javafx.geometry.Bounds;
import javafx.scene.Group;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.Box;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;

public class Obstacle {

    public Obstacle(){
        WindowSize = 500;
        xTranslation = 605;
        yTranslation = 205;
        zTranslation = 5;

        double x, y, z;
        String posKey;
        for(int i = 0; i<100; i++){
            Random rand = new Random();
            do {
                x = rand.nextDouble() * 350 + 100; // Random position for x
                y = rand.nextDouble() * 350 + 100; // Random position for y
                z = rand.nextDouble() * 350 + 100; // Random position for z
                posKey = x + "," + y + "," + z;   // Create a key for the set
            } while (occupiedPositions.contains(posKey)); // Ensure uniqueness

            occupiedPositions.add(posKey); // Add the new position to the set

            Box cube = new Box(obSize,obSize,obSize);
            cube.setMaterial(new PhongMaterial(Color.ORANGERED));
            cube.setTranslateX(xTranslation + (x));
            cube.setTranslateY(yTranslation + (y));
            cube.setTranslateZ(zTranslation + (z));
            obstacles.add(cube);
            obstacleBounds.add(cube.getBoundsInParent());
        }
    }

    public Obstacle(int WindowSize, int xTranslation, int yTranslation, int obSize, int objNum){
        this.obSize = obSize/2;
        this.WindowSize = WindowSize;
        this.xTranslation = xTranslation + obSize/2;
        this.yTranslation = yTranslation + obSize/2;
        zTranslation = obSize/2;
        this.objNum = objNum;

        double x, y, z;
        String posKey;
        for(int i = 0; i<objNum; i++){
            Random rand = new Random();
            do {
                x = rand.nextDouble() * 350 + 100; // Random position for x
                y = rand.nextDouble() * 350 + 100; // Random position for y
                z = rand.nextDouble() * 350 + 100; // Random position for z
                posKey = x + "," + y + "," + z;   // Create a key for the set
            } while (occupiedPositions.contains(posKey)); // Ensure uniqueness

            occupiedPositions.add(posKey); // Add the new position to the set

            Box cube = new Box(obSize,obSize,obSize);
            cube.setMaterial(new PhongMaterial(Color.ORANGERED));
            cube.setTranslateX(xTranslation + (x));
            cube.setTranslateY(yTranslation + (y));
            cube.setTranslateZ(zTranslation + (z));
            obstacles.add(cube);
            obstacleBounds.add(cube.getBoundsInParent());
        }
    }


    public void addToGroup(Group group){
        for(Box b: obstacles){
            group.getChildren().add(b);
        }
    }
    public ArrayList<Box> getObstacles() {
        return obstacles;
    }

    public ArrayList<Bounds> getObstacleBounds() {
        return obstacleBounds;
    }

    public boolean checkCollision(Bounds otherBounds) {
        for (Bounds bounds : obstacleBounds) {
            if (bounds.intersects(otherBounds)) {
                return true;
            }
        }
        return false;
    }

    int WindowSize = 0;
    int xTranslation, yTranslation, zTranslation, objNum;

    int obSize = 10;
    Set<String> occupiedPositions = new HashSet<>();
    ArrayList<Box> obstacles = new ArrayList<Box>();
    ArrayList<Bounds> obstacleBounds = new ArrayList<Bounds>();
}
